#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_EffectCFG.h"
std::auto_ptr<Fish_EffectCFG> Fish_EffectCFG::msSingleton(nullptr);

int Fish_EffectCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_EffectCFGData* Fish_EffectCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_EffectCFGData>& Fish_EffectCFG::GetMapData()
{
	return mMapData;
}

void Fish_EffectCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_EffectCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_EffectCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mEffectType = element->IntAttribute("EffectType");
		{
			const char* ResParams = element->Attribute("ResParams");
			std::vector<std::string> vecResParams;
			boost::split(vecResParams, ResParams, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecResParams.size(); i++)
			{
				data.mResParams.push_back(vecResParams[i]);
			}
		}
		data.mDuration = element->FloatAttribute("Duration");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_EffectCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_EffectCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_EffectCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_EffectCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_EffectCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "EffectType", data.mEffectType);
		LuaCfgHelper::readVectorString(L, "ResParams", data.mResParams);
		LuaCfgHelper::readFloat(L, "Duration", data.mDuration);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_EffectCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_EffectCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_EffectCFG* Fish_EffectCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_EffectCFG());
	}
	return msSingleton.get();
}

void Fish_EffectCFG::Release()
{
	msSingleton.reset(nullptr);
}
